svn commit: r340069 - head/tests/sys/netpfil/pf

Kristof Provost kp at FreeBSD.org
Fri Nov 2 16:59:56 UTC 2018


Author: kp
Date: Fri Nov  2 16:59:55 2018
New Revision: 340069
URL: https://svnweb.freebsd.org/changeset/base/340069

Log:
  pf tests: Basic pfsync test
  
  Set up two jails, configure pfsync between them and create state in one
  of them, verify that this state is copied to the other jail.
  
  MFC after:	2 weeks
  Sponsored by:	Orange Business Services
  Differential Revision:	https://reviews.freebsd.org/D17504

Added:
  head/tests/sys/netpfil/pf/pfsync.sh   (contents, props changed)
Modified:
  head/tests/sys/netpfil/pf/Makefile
  head/tests/sys/netpfil/pf/utils.subr

Modified: head/tests/sys/netpfil/pf/Makefile
==============================================================================
--- head/tests/sys/netpfil/pf/Makefile	Fri Nov  2 16:57:23 2018	(r340068)
+++ head/tests/sys/netpfil/pf/Makefile	Fri Nov  2 16:59:55 2018	(r340069)
@@ -11,7 +11,8 @@ ATF_TESTS_SH+=	pass_block \
 		set_tos \
 		route_to \
 		synproxy \
-		set_skip
+		set_skip \
+		pfsync
 
 ${PACKAGE}FILES+=	utils.subr \
 			echo_inetd.conf \

Added: head/tests/sys/netpfil/pf/pfsync.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ head/tests/sys/netpfil/pf/pfsync.sh	Fri Nov  2 16:59:55 2018	(r340069)
@@ -0,0 +1,70 @@
+# $FreeBSD$
+
+. $(atf_get_srcdir)/utils.subr
+
+atf_test_case "basic" "cleanup"
+basic_head()
+{
+	atf_set descr 'Basic pfsync test'
+	atf_set require.user root
+
+	atf_set require.progs scapy
+}
+
+basic_body()
+{
+	pfsynct_init
+
+	epair_sync=$(pft_mkepair)
+	epair_one=$(pft_mkepair)
+	epair_two=$(pft_mkepair)
+
+	pft_mkjail one ${epair_one}a ${epair_sync}a
+	pft_mkjail two ${epair_two}a ${epair_sync}b
+
+	# pfsync interface
+	jexec one ifconfig ${epair_sync}a 192.0.2.1/24 up
+	jexec one ifconfig ${epair_one}a 198.51.100.1/24 up
+	jexec one ifconfig pfsync0 \
+		syncdev ${epair_sync}a \
+		maxupd 1 \
+		up
+	jexec two ifconfig ${epair_two}a 198.51.100.2/24 up
+	jexec two ifconfig ${epair_sync}b 192.0.2.2/24 up
+	jexec two ifconfig pfsync0 \
+		syncdev ${epair_sync}b \
+		maxupd 1 \
+		up
+
+	# Enable pf!
+	jexec one pfctl -e
+	pft_set_rules one \
+		"set skip on ${epair_sync}a" \
+		"pass keep state"
+	jexec two pfctl -e
+	pft_set_rules two \
+		"set skip on ${epair_sync}b" \
+		"pass keep state"
+
+	ifconfig ${epair_one}b 198.51.100.254/24 up
+
+	ping -c 1 -S 198.51.100.254 198.51.100.1
+
+	# Give pfsync time to do its thing
+	sleep 2
+
+	if ! jexec two pfctl -s states | grep icmp | grep 198.51.100.1 | \
+	    grep 198.51.100.2 ; then
+		atf_fail "state not found on synced host"
+	fi
+}
+
+basic_cleanup()
+{
+	pfsynct_cleanup
+}
+
+atf_init_test_cases()
+{
+	atf_add_test_case "basic"
+}

Modified: head/tests/sys/netpfil/pf/utils.subr
==============================================================================
--- head/tests/sys/netpfil/pf/utils.subr	Fri Nov  2 16:57:23 2018	(r340068)
+++ head/tests/sys/netpfil/pf/utils.subr	Fri Nov  2 16:59:55 2018	(r340069)
@@ -13,6 +13,15 @@ pft_init()
 	fi
 }
 
+pfsynct_init()
+{
+	pft_init
+
+	if ! kldstat -q -m pfsync; then
+		atf_skip "This test requires pfsync"
+	fi
+}
+
 pft_mkepair()
 {
 	ifname=$(ifconfig epair create)
@@ -66,4 +75,9 @@ pft_cleanup()
 		done
 		rm created_interfaces.lst
 	fi
+}
+
+pfsynct_cleanup()
+{
+	pft_cleanup
 }


More information about the svn-src-head mailing list